package main

import (
	"encoding/csv"
	"fmt"
	"io"
	"os"
	"strconv"
)

const TEMP_FILE = "test.csv"

func write(m map[int]string) error {
	//os.Remove(TEMP_FILE)
	file, err := os.Create(TEMP_FILE)
	if err != nil {
		return err
	}
	defer file.Close()

	// write title
	writer := csv.NewWriter(file)
	err = writer.Write([]string{"no", "url"})
	if err != nil {
		return err
	}

	// write content
	for k, v := range m {
		err = writer.Write([]string{strconv.Itoa(k), v})
		if err != nil {
			return err
		}
	}
	writer.Flush()

	return nil
}

func read() ([][]string, error) {
	var records [][]string
	file, err := os.Open(TEMP_FILE)
	if err != nil {
		return nil, err
	}
	defer file.Close()

	reader := csv.NewReader(file)
	// records, err := reader.ReadAll()
	for {
		line, err := reader.Read()
		if err != nil {
			if err == io.EOF {
				break
			}
			return nil, err
		}
		records = append(records, line)
	}
	return records, nil
}

func main() {
	m := map[int]string{}
	m[1] = "https://www.xiexianbin.cn/index.html"
	m[2] = "https://www.xiexianbin.cn/404.html"
	err := write(m)
	fmt.Println(err)

	records, err := read()
	fmt.Println(records, err)
}
